
from random import randint

q = 18434813901432784897 # 64-bit prime
mu= 18458681966650671896 # 65-bit floor(2^128 / q)

def barrett(D):
    s = (D * mu) >> 128
    r = s * q
    u = D - r
    C = u - q if(u >= q) else u
    return C

A = randint(0, q-1)
B = randint(0, q-1)

D = A * B

C = barrett(D)
C_expected = D % q

print("C:", C, "C_expected:", C_expected, "C == C_expected ?:", C == C_expected)

